"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.commandNames = void 0;
exports.rcOptionsTypes = rcOptionsTypes;
exports.cliOptionsTypes = cliOptionsTypes;
exports.help = help;
exports.handler = handler;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const cli_utils_1 = require("@pnpm/cli-utils");
const cli_meta_1 = require("@pnpm/cli-meta");
const client_1 = require("@pnpm/client");
const pick_registry_for_package_1 = require("@pnpm/pick-registry-for-package");
const config_1 = require("@pnpm/config");
const error_1 = require("@pnpm/error");
const tools_path_1 = require("@pnpm/tools.path");
const logger_1 = require("@pnpm/logger");
const link_bins_1 = require("@pnpm/link-bins");
const pick_1 = __importDefault(require("ramda/src/pick"));
const render_help_1 = __importDefault(require("render-help"));
const add = __importStar(require("./add"));
function rcOptionsTypes() {
    return (0, pick_1.default)([], config_1.types);
}
function cliOptionsTypes() {
    return {
        ...rcOptionsTypes(),
    };
}
exports.commandNames = ['self-update'];
function help() {
    return (0, render_help_1.default)({
        description: '',
        descriptionLists: [],
        url: (0, cli_utils_1.docsUrl)('self-update'),
        usages: [],
    });
}
async function handler(opts, params) {
    const { resolve } = (0, client_1.createResolver)({ ...opts, authConfig: opts.rawConfig });
    const pkgName = 'pnpm';
    const resolution = await resolve({ alias: pkgName, pref: 'latest' }, {
        lockfileDir: opts.lockfileDir ?? opts.dir,
        preferredVersions: {},
        projectDir: opts.dir,
        registry: (0, pick_registry_for_package_1.pickRegistryForPackage)(opts.registries, pkgName, 'latest'),
    });
    if (!resolution?.manifest) {
        throw new error_1.PnpmError('CANNOT_RESOLVE_PNPM', 'Cannot find latest version of pnpm');
    }
    if (resolution.manifest.version === cli_meta_1.packageManager.version) {
        (0, logger_1.globalInfo)('Already the latest version is installed');
        return;
    }
    const currentPkgName = (0, cli_meta_1.getCurrentPackageName)();
    const dir = (0, tools_path_1.getToolDirPath)({
        pnpmHomeDir: opts.pnpmHomeDir,
        tool: {
            name: currentPkgName,
            version: resolution.manifest.version,
        },
    });
    if (fs_1.default.existsSync(dir)) {
        (0, logger_1.globalInfo)(`Latest version is already present on the system. Linking from ${opts.dir}`);
        await (0, link_bins_1.linkBins)(path_1.default.join(opts.dir, opts.modulesDir ?? 'node_modules'), opts.pnpmHomeDir, {
            warn: () => { },
        });
        return;
    }
    const version = resolution.manifest.version;
    fs_1.default.mkdirSync(dir, { recursive: true });
    fs_1.default.writeFileSync(path_1.default.join(dir, 'package.json'), '{}');
    await add.handler({
        ...opts,
        dir,
        lockfileDir: dir,
        bin: opts.pnpmHomeDir,
    }, [`${currentPkgName}@${version}`]);
}
//# sourceMappingURL=selfUpdate.js.map